#!/bin/sh
glilang=en

echo
if [ "$glilang" == "es" ]; then
    echo "Editar conjuntos de metadatos (Greenstone Editor for Metadata Sets - GEMS)"
    echo "Copyright (C) 2005, New Zealand Digital Library Project, University Of Waikato"
    echo "GEMS NO INCLUYE ABSOLUTAMENTE NINGUNA GARANTA."
    echo "Para mayor informacin vea los trminos de la licencia en LICENSE.txt"
    echo "Este es un software abierto, por lo que lo invitamos a que lo distribuya de forma gratuita"
elif [ "$glilang" == "fr" ]; then
    echo "Editer les jeux de mta-donnes (Greenstone Editor for Metadata Sets - GEMS)"
    echo "Copyright (C) 2005, New Zealand Digital Library Project, University Of Waikato"
    echo "GEMS est fourni sans AUCUNE GARANTIE; pour des dtails, voir LICENSE.txt"
    echo "Ceci est un logiciel libre, et vous tes invit  le redistribuer"
elif [ "$glilang" == "ru" ]; then
    echo "   (Greenstone Editor for Metadata Sets - GEMS)"
    echo "Copyright (C) 2005, New Zealand Digital Library Project, University Of Waikato"
    echo "     ;  .   LICENSE.TXT"
    echo " -         "
else
    echo "Greenstone Editor for Metadata Sets (GEMS)"
    echo "Copyright (C) 2005, New Zealand Digital Library Project, University Of Waikato"
    echo "GEMS comes with ABSOLUTELY NO WARRANTY; for details see LICENSE.txt"
    echo "This is free software, and you are welcome to redistribute it"
fi
echo

##  -------- Run the Greenstone Editor for Metadata Sets --------

# This script must be run from within the directory in which it lives
thisdir=`pwd`
if [ ! -f "${thisdir}/gems.sh" ]; then
    if [ "$glilang" == "es" ]; then
        echo "Este guin deber ejecutarse desde el directorio en el que reside."
    elif [ "$glilang" == "fr" ]; then
	echo "Ce script doit tre excut  partir du rpertoire dans lequel il se trouve."
    elif [ "$glilang" == "ru" ]; then
	echo "      ,    "
    else
	echo "This script must be run from the directory in which it resides."
    fi
    exit 1
fi


##  ---- Determine GSDLHOME ----
gsdlpath=

# Some users may set the above line manually
if [ "$gsdlpath" == "" ]; then
    # Check the environment variable first
    if [ "$GSDLHOME" != "" ]; then
	gsdlpath=$GSDLHOME

    # If it is not set, assume that the GLI (and thus GEMS) is installed as a subdirectory of Greenstone
    else
	pushd .. > /dev/null
	gsdlpath=`pwd`
	popd > /dev/null
    fi
fi

# Check that the Greenstone installation looks OK
if [ "$glilang" == "es" ]; then
    echo "Revisando GSDL: $gsdlpath"
elif [ "$glilang" == "fr" ]; then
    echo "Vrification de GSDL: $gsdlpath"
elif [ "$glilang" == "ru" ]; then
    echo " GSDL: $gsdlpath"
else
    echo "Checking GSDL: $gsdlpath"
fi
if [ ! -f "${gsdlpath}/setup.bash" ] ; then
    echo
    if [ "$glilang" == "es" ]; then
	echo "No se pudo encontrar la instalacin de Greenstone o est incompleta."
        echo "Trate de reinstalar Greenstone y a continuacin ejecute nuevamente"
	echo "este guin."
    elif [ "$glilang" == "fr" ]; then
	echo "L'installation de Greenstone est introuvable ou incomplte."
	echo "Essayez de rinstaller Greenstone et excutez ce script  nouveau."
    elif [ "$glilang" == "ru" ]; then
	echo " Greenstone      ."
	echo "   Greenstone,      ."
    else
	echo "The Greenstone installation could not be found, or is incomplete."
	echo "Try reinstalling Greenstone then running this script again."
    fi
    exit 1
fi

# Setup Greenstone, unless it has already been done
if [ "$GSDLHOME" == "" ]; then
    pushd "$gsdlpath" > /dev/null
    source setup.bash
    popd > /dev/null
fi


## ---- Check Java exists ----
javapath=

# Some users may set the above line manually
if [ "$javapath" == "" ]; then

    # If it is set, use the JAVA_HOME environment variable
    if [ "$JAVA_HOME" != "" ]; then
	javapath="$JAVA_HOME/bin/java"

    # Check if Java is on the search path
    else
	javapath=`which java 2> /dev/null`
    fi
fi

# Check that a Java executable has been found
if [ "$glilang" == "es" ]; then
    echo "Revisando Java: $javapath"
elif [ "$glilang" == "fr" ]; then
    echo "Vrification de Java: $javapath"
elif [ "$glilang" == "ru" ]; then
    echo " Java: $javapath"
else
    echo "Checking Java: $javapath"
fi
if [ ! -x "$javapath" ]; then
    echo
    if [ "$glilang" == "es" ]; then
	echo "No se pudo localizar una versin apropiada de Java. Usted deber "
	echo "instalar un Ambiente de Ejecucin Java (versin 1.4 o superior) "
	echo "antes de correr la Editar conjuntos de metadatos."
    elif [ "$glilang" == "fr" ]; then
	echo "Une version adquate de Java n'a pas pu tre localise."
	echo "Vous devez installer un Java Runtime Environment (version 1.4 ou"
	echo "suprieur) avant de dmarrer Editer les jeux de mta-donnes."
    elif [ "$glilang" == "ru" ]; then
	echo "      Java."
	echo "   Java Runtime Environment ( 1.4  )"
	echo "    ."
    else
	echo "Failed to locate an appropriate version of Java. You must install a"
	echo "Java Runtime Environment (version 1.4 or greater) before running the"
	echo "Greenstone Editor for Metadata Sets."
    fi
    exit 1
fi


## -- Check the version of Java is new enough (1.4.0 or higher) to run the GEMS --
`$javapath -classpath . CheckJavaVersion > /dev/null`
if [ $? -ne 2 ] ; then
    echo
    if [ "$glilang" == "es" ]; then
	echo "La versin del Ambiente de Ejecucin Java (JRE por sus siglas en "
	echo "ingls) que usted tiene instalada es demasiado vieja para ejecutar "
	echo "la Editar conjuntos de metadatos. Por favor instale una nueva "
	echo "versin del Ambiente de Ejecucin Java (versin 1.4 o posterior)"
	echo "y ejecute nuevamente este guin."
    elif [ "$glilang" == "fr" ]; then
	echo "La version de Java Runtime Environment que vous avez installe est"
	echo "trop vielle pour faire fonctionner Editer les jeux de mta-donnes."
	echo "Veuillez installer une nouvelle version du JRE (version 1.4 ou plus"
	echo "rcente) et redmarrez le script."
    elif [ "$glilang" == "ru" ]; then
	echo " Java Runtime Environment,   ,  ,"
	echo "    . , "
	echo "   JRE ( 1.4   ) "
	echo "  "
    else
	echo "The version of the Java Runtime Environment you have installed is too"
	echo "old to run the Greenstone Editor for Metadata Sets. Please install a new"
	echo "version of the JRE (version 1.4 or newer) and rerun this script."
    fi
    exit 1
fi


## ---- Check that the GEMS has been compiled ----
if [ ! -f "classes/org/greenstone/gatherer/gems/GEMS.class" ] && [ ! -f "GLI.jar" ]; then
    echo
    if [ "$glilang" == "es" ]; then
	echo "Usted necesita compilar la Editar conjuntos de metadatos"
	echo "(por medio de makegli.sh) antes de ejecutar este guin."
    elif [ "$glilang" == "fr" ]; then
	echo "Vous devez compiler le Editer les jeux de mta-donnes (en utilisant makegli.sh)"
	echo "avant d'excuter ce script."
    elif [ "$glilang" == "ru" ]; then
	echo "     "
	echo "( makegli.sh)    "
    else
	echo "You need to compile the Greenstone Editor for Metadata Sets (using makegli.sh)"
	echo "before running this script."
    fi
    exit 1
fi


## ---- Finally, run the GEMS ----
echo
if [ "$glilang" == "es" ]; then
    echo "Ejecutando la Editar conjuntos de metadatos..."
elif [ "$glilang" == "fr" ]; then
    echo "Excution de Editer les jeux de mta-donnes"
elif [ "$glilang" == "ru" ]; then
    echo "   ..."
else
    echo "Running the Greenstone Editor for Metadata Sets..."
fi

# Other arguments you can provide to GEMS to work around memory limitations, or debug
# -Xms<number>M    To set minimum memory (by default 32MB)
# -Xmx<number>M    To set maximum memory (by default the nearest 2^n to the total remaining physical memory)
# -verbose:gc      To set garbage collection messages
# -Xincgc          For incremental garbage collection (significantly slows performance)
# -Xprof           Function call profiling
# -Xloggc:<file>   Write garbage collection log

$javapath -classpath classes/:GLI.jar:lib/apache.jar org.greenstone.gatherer.gems.GEMS -gsdl $GSDLHOME $*

if [ "$glilang" == "es" ]; then
    echo "Hecho!"
elif [ "$glilang" == "fr" ]; then
    echo "Termin!"
elif [ "$glilang" == "ru" ]; then
    echo "!"
else
    echo "Done!"
fi